import { createAsyncThunk } from "@reduxjs/toolkit";
import axios from "axios";
import { LOADING_END, LOADING_START } from "../../../lib/redux/slices/appSlice";

export const provincePolicyGetWeightCategory = createAsyncThunk(
  "PROVINCE_POLICY_GET_WEIGHT_CATEGORY",
  async (d, { dispatch }) => {
    dispatch(LOADING_START());
    const { data, status } = await axios.get("index-weight-category/");
    dispatch(LOADING_END());
    return { data, status };
  }
);

export const provincePolicySubmitWeightCategory = createAsyncThunk(
  "PROVINCE_POLICY_SUBMIT_WEIGHT_CATEGORY",
  async (d, { dispatch }) => {
    dispatch(LOADING_START());
    try {
      const { data, status } = await axios.post("index-weight-category/", d);
      dispatch(LOADING_END());
      return { data, status };
    } catch (e) {
      dispatch(LOADING_END());
      return { error: e.response.data.result };
    }
  }
);

export const provincePolicyEditWeightCategory = createAsyncThunk(
  "PROVINCE_POLICY_EDIT_WEIGHT_CATEGORY",
  async (d, { dispatch }) => {
    dispatch(LOADING_START());
    try {
      const { data, status } = await axios.put(`index-weight-category/0/`, d);
      dispatch(LOADING_END());
      return { data, status };
    } catch (e) {
      dispatch(LOADING_END());
      return { error: e.response.data.result };
    }
  }
);

export const provincePolicyDeleteWeightCategory = createAsyncThunk(
  "PROVINCE_DELETE_WEIGHT_CATEGORY",
  async (d, { dispatch }) => {
    dispatch(LOADING_START());
    try {
      const { data, status } = await axios.delete(
        `index-weight-category/${d}/`
      );
      dispatch(LOADING_END());
      return { data, status };
    } catch (e) {
      dispatch(LOADING_END());
      return { error: e.response.data.result };
    }
  }
);
